'    Digital-Check Logger
'    --------------------
'    Copyright (C) 2008 Sandro Barsi 
'
'    This program is free software: you can redistribute it and/or modify it 
'    under the terms of the GNU General Public License as published by the Free 
'    Software Foundation version 3 of the License. 
'    This program is distributed in the hope that it will be useful, but WITHOUT 
'    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
'    FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
'    more details. 
'    You should have received a copy of the GNU General Public License along with 
'    this program. If not, see http://www.gnu.org/licenses/. 
'
'    Per contattarmi puoi visitare il sito http://www.lambdatechnology.it    
'    o scrivermi ad uno dei seguenti indirizzi      info@lambdatechnology.it 
'                                                   s.barsi@tin.it
'
'
Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class MainForm
	Inherits System.Windows.Forms.Form
	'
	'   vendor and product IDs
	'   ======================
	Private Const VendorID As Short = 6017
	Private Const ProductID As Short = 2000
	'
	'   In and Out buffers
	'   ==================
	Private Const BufferInSize As Short = 8
	Private Const BufferOutSize As Short = 8
	Dim BufferIn(BufferInSize) As Byte
    Dim BufferOut(BufferOutSize) As Byte
    Dim ValMin(16) As Single
    Dim ValMax(16) As Single
    Dim ValDec(16) As Byte
    Dim Prima, Registra As Boolean
    Dim NomeFile As String
    Dim SuGrafico As Boolean
    Dim Barra As Integer
    Public Structure Istante
        Dim Tempo As String
        Dim Parametro As Byte
        Dim Valore As Single
    End Structure
    Public Lettura(2) As Istante

    Private Sub Check_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Check.CheckStateChanged
        Dim Index As Short = Check.GetIndex(eventSender)

        Dim i As Byte

        If Check(Index).CheckState = 0 Then
            If Index < Check.Count - 1 Then
                ProgressBar(Index).Value = ProgressBar(Index).Minimum
                ProgressBar(Index).Refresh()
                Label(Index).Text = CStr(0)
                Label(Index).Refresh()
            Else
                For i = 0 To LabelErrori.Count - 1
                    LabelErrori(i).BackColor = System.Drawing.ColorTranslator.FromOle(&H8000000F)
                    LabelErrori(i).Refresh()
                Next i
            End If
        End If

    End Sub

    Private Sub CommandClr_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CommandClr.Click
        TextTrasm.Text = ""
    End Sub

    Private Sub MainForm_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim i As Byte
        Dim bm As New Bitmap(PictureGrafico.Width, PictureGrafico.Height)
        Dim gr As Graphics = Graphics.FromImage(bm)

        ConnectToHID(Me.Handle.ToInt32) ' connect to HID
        Me.Text = "Digital-Check Logger" ' Form title
        '
        '   Clear labels and Text boxes
        '   ===========================
        lVendorName.Text = ""
        lProductName.Text = ""
        LabelModello.Text = ""
        For i = 0 To Check.Count - 2
            Check(i).CheckState = System.Windows.Forms.CheckState.Unchecked
            ProgressBar(i).Value = ProgressBar(i).Minimum
            Label(i).Text = CStr(0)
        Next i
        Check(Check.Count - 1).CheckState = System.Windows.Forms.CheckState.Unchecked
        For i = 0 To 15
            LabelErrori(i).BackColor = System.Drawing.ColorTranslator.FromOle(&H8000000F)
        Next i
        CheckFinestra.CheckState = System.Windows.Forms.CheckState.Unchecked

        LabelStatus.Text = "Disconnesso"

        '   Clear BufferOut and send initial data to the USB device
        Dim Index As Byte
        For Index = 0 To 8 '
            BufferOut(Index) = 0 ' set all array to '0'
        Next  '
        Lettura(0).Valore = 0
        Lettura(1).Valore = 0
        HScrollBar.Maximum = 1

        FaiRange()

        Dim a, b, c As Single
        For Index = 0 To 14
            a = ValMax(Index)
            b = Int(a)
            c = a - b
            If c = 0 Then
                ValDec(Index) = 0
            Else
                a = a * 10
                b = Int(a)
                c = a - b
                If c = 0 Then
                    ValDec(Index) = 1
                Else
                    a = a * 10
                    b = Int(a)
                    c = a - b
                    If c = 0 Then
                        ValDec(Index) = 2
                    Else
                        ValDec(Index) = 3
                    End If
                End If
            End If
            ProgressBar(Index).Minimum = 0
            If ValMin(Index) < 0 Then
                ProgressBar(Index).Maximum = (ValMax(Index) - ValMin(Index)) * (10 ^ ValDec(Index))
            Else
                ProgressBar(Index).Maximum = ValMax(Index) * (10 ^ ValDec(Index))
            End If
        Next

        Registra = False
        SuGrafico = False

        gr.Clear(Color.Black)

        PictureGrafico.Image = bm

        WriteSomeData() ' Send initial data

    End Sub

    Private Sub MainForm_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        DisconnectFromHID() ' disconnect from the HID controller...
        SplashScreen.Close()
    End Sub

    Public Sub OnPlugged(ByVal pHandle As Integer)
        '
        '   A HID device has been plugged in,
        '   check if it's the right one, and enable the form LED (top left)
        '
        Dim DeviceHandle As Integer
        Dim VendorName As New VB6.FixedLengthString(15)
        Dim ProductName_Renamed As New VB6.FixedLengthString(15)

        If hidGetVendorID(pHandle) = VendorID And hidGetProductID(pHandle) = ProductID Then ' Good one?
            '
            '   get the device handle
            '   =====================
            DeviceHandle = hidGetHandle(VendorID, ProductID)
            '
            '   Get the vendor and product name from the handle
            '   ===============================================
            hidGetVendorName(DeviceHandle, VendorName.Value, 255)
            hidGetProductName(DeviceHandle, ProductName_Renamed.Value, 255)
            '
            '   Enable the LED and display device information
            '   VendorName and ProductName
            '   =============================================
            LabelStatus.Text = "Connesso"
            lVendorName.Text = VendorName.Value
            lProductName.Text = ProductName_Renamed.Value
            Prima = True
        End If
    End Sub

    Public Sub OnUnplugged(ByVal pHandle As Integer)
        '
        '   A HID device has been unplugged,
        '   check if it's the right one and clear all related LEDs, Labels, ProgressBar..etc
        '
        Dim i As Byte

        If hidGetVendorID(pHandle) = VendorID And hidGetProductID(pHandle) = ProductID Then ' good one?
            hidSetReadNotify(hidGetHandle(VendorID, ProductID), False)
            lVendorName.Text = ""
            lProductName.Text = ""
            LabelStatus.Text = "Disconnesso"
            For i = 0 To Check.Count - 2
                Check(i).CheckState = System.Windows.Forms.CheckState.Unchecked
                ProgressBar(i).Value = ProgressBar(i).Minimum
                Label(i).Text = CStr(0)
            Next i
            Check(Check.Count - 1).CheckState = System.Windows.Forms.CheckState.Unchecked
            For i = 0 To 15
                LabelErrori(i).BackColor = System.Drawing.ColorTranslator.FromOle(&H8000000F)
            Next i
            CheckFinestra.CheckState = System.Windows.Forms.CheckState.Unchecked
            LabelModello.Text = ""
        End If
    End Sub

    Public Sub OnChanged()
        '
        '   Something happen!
        '   Controller changed notification - called
        '   after ALL HID devices are plugged or unplugged
        '
        '   Get the handle of the device we are interested in, then set
        '   its read notify flag to true - this ensures you get a read
        '   notification message when there is some data to read...
        '
        '   Deuh??? still there?
        '
        Dim DeviceHandle As Integer
        DeviceHandle = hidGetHandle(VendorID, ProductID)
        '        hidSetReadNotify(DeviceHandle, True)
        hidSetReadNotify(hidGetHandle(VendorID, ProductID), True)
    End Sub

    Public Sub OnRead(ByVal pHandle As Integer)
        '
        '   There's some incomming data here :o)
        '   read it and have fun.
        '   Don't forget Bufferin(0) is the ReportID
        '
        '   When BufferIn(7) and BufferIn(8) = 0 we receive the PORTA pins
        '   Status and the ADCs value, case else (for now) it's a text string to be display
        '   in the TUSBRx TextBox.
        '
        Dim Decimali, temp, ValoreH, Codice, ValoreL, MaxCheck, i, a As Byte
        Dim Valore, Vtemp As Long
        Dim Trovato, Segno As Boolean
        Dim Lstring, Linea, Stemp As String

        MaxCheck = Check.Count

        If hidRead(pHandle, BufferIn(0)) Then ' valid ReportID?

            '   Lettura e visualizzazione valori
            Codice = BufferIn(1)
            If Codice = MaxCheck Then
                Decimali = Val(CStr(BufferIn(2)))
                ValoreH = Val(CStr(BufferIn(3)))
                ValoreL = Val(CStr(BufferIn(4)))
                Valore = ValoreH * 256 + ValoreL
                If Valore = 1 Then EvoKat()
                If Valore = 2 Then EvoKatg()
                If Valore = 3 Then Evo()
                If Valore = 4 Then Evog()
                If Valore = 5 Then i8v()
                If Valore = 6 Then i8vg()
                LabelModello.Text = "Modello DCM" & VB.Right("00" & CStr(Valore), 2)
            Else
                temp = Codice
                If Check(temp).CheckState = 1 Then
                    Decimali = Val(CStr(BufferIn(2)))
                    ValoreH = Val(CStr(BufferIn(3)))
                    ValoreL = Val(CStr(BufferIn(4)))
                    Valore = ValoreH * 256 + ValoreL
                    If temp < MaxCheck - 1 Then ' valori arrivati
                        Segno = False
                        If Decimali > 127 Then
                            Segno = True
                            Decimali = Decimali - 128
                        End If
                        If Segno And Valore > 64000 Then
                            Valore = 0 - (65536 - Valore)
                        End If

                        ProgressBar(temp).Value = Valore - (ValMin(temp) * (10 ^ ValDec(temp)))

                        Lstring = CStr(Valore)
                        If Decimali > 0 Then
                            If Decimali >= Len(Lstring) Then
                                a = Decimali - Len(Lstring)
                                For i = 0 To a
                                    Lstring = "0" & Lstring
                                Next i
                            End If
                            Lstring = VB.Left(Lstring, Len(Lstring) - Decimali) & "," & VB.Right(Lstring, Decimali)
                        End If
                        Label(temp).Text = Lstring
                        Label(temp).Refresh()
                        If Registra Then
                            Stemp = Mid(CStr(Now), 12, Len(CStr(Now)) - 10)
                            Stemp = Mid("0" & Stemp, Len("0" & Stemp) - 7, 8)
                            Stemp = Replace(Stemp, ".", ":")
                            LabelTime.Text = Stemp
                            Stemp = Mid(CStr(Now), 1, 10)
                            Linea = Stemp & " " & LabelTime.Text & " ; " & CStr(temp) & " ; " & Lstring & vbCr & vbLf
                            My.Computer.FileSystem.WriteAllText(NomeFile, Linea, True)
                        Else
                            LabelTime.Text = "00:00:00"
                        End If
                    End If
                    If temp = MaxCheck - 1 Then ' errori arrivati
                        Vtemp = Valore
                        For i = 0 To 15
                            a = 15 - i
                            If Vtemp >= (2 ^ a) Then
                                LabelErrori(a).BackColor = System.Drawing.Color.Red
                                LabelErrori(a).Refresh()
                                Vtemp = Vtemp - (2 ^ a)
                            Else
                                LabelErrori(a).BackColor = System.Drawing.ColorTranslator.FromOle(&H8000000F)
                                LabelErrori(a).Refresh()
                            End If
                        Next i
                    End If
                End If
            End If


            If CheckFinestra.CheckState = 1 Then
                For i = 0 To 8
                    TextTrasm.Text = TextTrasm.Text & " " & VB.Right("00" & Hex(BufferIn(i)), 2)
                Next i
                TextTrasm.Text = TextTrasm.Text & " --"
            End If

            '   Ricerca prossimo valore da chiedere

            Trovato = False
            For temp = 0 To MaxCheck - 1
                If Check(temp).CheckState = 1 Then Trovato = True
            Next temp
            If Trovato Then
                temp = Val(Labelindice.Text)
                If temp >= MaxCheck Then temp = 0
                While Check(temp).CheckState = 0
                    temp = temp + 1
                    If temp = MaxCheck Then temp = 0
                End While
            Else
                temp = MaxCheck
            End If
            If Prima Then
                temp = MaxCheck
                Prima = False
            End If
            BufferOut(1) = temp
            temp = temp + 1
            Labelindice.Text = temp

            If CheckFinestra.CheckState = 1 Then
                For i = 0 To 8
                    TextTrasm.Text = TextTrasm.Text & " " & VB.Right("00" & Hex(BufferOut(i)), 2)
                Next i
                TextTrasm.Text = TextTrasm.Text & vbCr & vbLf
                TextTrasm.SelectionStart = Len(TextTrasm.Text)
            End If
            WriteSomeData()
        End If
    End Sub

    Public Sub WriteSomeData()
        '
        '   Use to send data to the USB bus.
        '   data must be store in BufferOut array
        '
        '   Actual structure:
        '   -----------------
        '       BufferOut(0) = Report id => always 0
        '       BufferOut(1) = LEDS  ' first data item, etc etc
        '       BufferOut(2) = HPWM slider1 MSB
        '       BufferOut(3) = HPWM slider1 LSB
        '       BufferOut(4) = HPWM slider2 MSB
        '       BufferOut(5) = HPWM slider2 LSB
        '       BufferOut(6) = n/a = 0
        '       BufferOut(7) = n/a = 0
        '       BufferOut(8) = n/a = 0
        '
        BufferOut(0) = 0 ' first by is always the report ID

        hidWriteEx(VendorID, ProductID, BufferOut(0)) ' send it
    End Sub

    Public Sub EvoKat()

        Dim i As Byte

        Check(0).Enabled = True 'giri
        ProgressBar(0).Enabled = True
        Label(0).Enabled = True

        Check(1).Enabled = True 'iniezione
        ProgressBar(1).Enabled = True
        Label(1).Enabled = True

        Check(2).Enabled = True 'anticipo accenzione
        ProgressBar(2).Enabled = True
        Label(2).Enabled = True

        Check(3).Enabled = True 'pressione
        ProgressBar(3).Enabled = True
        Label(3).Enabled = True

        Check(4).Enabled = False 'pressione2
        ProgressBar(4).Enabled = False
        Label(4).Enabled = False

        Check(5).Enabled = False 'boost
        ProgressBar(5).Enabled = False
        Label(5).Enabled = False

        Check(6).Enabled = True 'farfalla
        ProgressBar(6).Enabled = True
        Label(6).Enabled = True

        Check(7).Enabled = True 'fase iniezione
        ProgressBar(7).Enabled = True
        Label(7).Enabled = True

        Check(8).Enabled = True 'vae
        ProgressBar(8).Enabled = True
        Label(8).Enabled = True

        Check(9).Enabled = True 'correzione lambda
        ProgressBar(9).Enabled = True
        Label(9).Enabled = True

        Check(10).Enabled = True 'temp aria
        ProgressBar(10).Enabled = True
        Label(10).Enabled = True

        Check(11).Enabled = True 'temp acqua
        ProgressBar(11).Enabled = True
        Label(11).Enabled = True

        Check(12).Enabled = True 'batteria
        ProgressBar(12).Enabled = True
        Label(12).Enabled = True

        Check(13).Enabled = False 'trimmer
        ProgressBar(13).Enabled = False
        Label(13).Enabled = False

        Check(14).Enabled = False 'temp gas
        ProgressBar(14).Enabled = False
        Label(14).Enabled = False

        Check(15).Enabled = True 'errori

        'pippowa   var     pippow.lowbyte
        'pippowb   var     pippow.highbyte
        LabelErrori(0).Text = "VAE" 'evae      var     pippowa.0
        LabelErrori(1).Text = "Carburazione" 'ecarb     var     pippowa.1
        LabelErrori(2).Text = "S. Aria" 'earia     var     pippowa.2
        LabelErrori(3).Text = "Detonazione" 'edet      var     pippowa.3
        LabelErrori(4).Text = "S. Acqua" 'eacqua    var     pippowa.4
        LabelErrori(5).Text = "S. Lambda" 'elambda   var     pippowa.5
        LabelErrori(6).Text = "S. Pressione" 'epres     var     pippowa.6
        LabelErrori(7).Text = "Farfalla" 'efarfa    var     pippowa.7
        LabelErrori(8).Text = "S. Fase" 'ecamma    var     pippowb.0
        LabelErrori(9).Text = "Seq. Dati" 'eseqdat   var     pippowb.1
        LabelErrori(10).Text = "Eprom" 'eepr      var     pippowb.2
        LabelErrori(11).Text = "Eeprom" 'eeepr     var     pippowb.3
        LabelErrori(12).Text = " " 'non usato var     pippowb.4
        LabelErrori(13).Text = " " 'non usato var     pippowb.5
        LabelErrori(14).Text = "Ram" 'eram      var     pippowb.6
        LabelErrori(15).Text = "S. Motore" 'esmot     var     pippowb.7

        For i = 0 To 15
            If LabelErrori(i).Text = " " Then
                LabelErrori(i).Enabled = False
            Else
                LabelErrori(i).Enabled = True
            End If
        Next i
    End Sub

    Public Sub EvoKatg()

        Dim i As Byte

        Check(0).Enabled = True 'giri
        ProgressBar(0).Enabled = True
        Label(0).Enabled = True

        Check(1).Enabled = True 'iniezione
        ProgressBar(1).Enabled = True
        Label(1).Enabled = True

        Check(2).Enabled = True 'anticipo accenzione
        ProgressBar(2).Enabled = True
        Label(2).Enabled = True

        Check(3).Enabled = True 'pressione
        ProgressBar(3).Enabled = True
        Label(3).Enabled = True

        Check(4).Enabled = False 'pressione2
        ProgressBar(4).Enabled = False
        Label(4).Enabled = False

        Check(5).Enabled = False 'boost
        ProgressBar(5).Enabled = False
        Label(5).Enabled = False

        Check(6).Enabled = True 'farfalla
        ProgressBar(6).Enabled = True
        Label(6).Enabled = True

        Check(7).Enabled = True 'fase iniezione
        ProgressBar(7).Enabled = True
        Label(7).Enabled = True

        Check(8).Enabled = True 'vae
        ProgressBar(8).Enabled = True
        Label(8).Enabled = True

        Check(9).Enabled = True 'correzione lambda
        ProgressBar(9).Enabled = True
        Label(9).Enabled = True

        Check(10).Enabled = True 'temp aria
        ProgressBar(10).Enabled = True
        Label(10).Enabled = True

        Check(11).Enabled = True 'temp acqua
        ProgressBar(11).Enabled = True
        Label(11).Enabled = True

        Check(12).Enabled = True 'batteria
        ProgressBar(12).Enabled = True
        Label(12).Enabled = True

        Check(13).Enabled = False 'trimmer
        ProgressBar(13).Enabled = False
        Label(13).Enabled = False

        Check(14).Enabled = True 'temp gas
        ProgressBar(14).Enabled = True
        Label(14).Enabled = True

        Check(15).Enabled = True 'errori

        'pippowa   var     pippow.lowbyte
        'pippowb   var     pippow.highbyte
        LabelErrori(0).Text = "VAE" 'evae      var     pippowa.0
        LabelErrori(1).Text = "Carburazione" 'ecarb     var     pippowa.1
        LabelErrori(2).Text = "S. Aria" 'earia     var     pippowa.2
        LabelErrori(3).Text = "Detonazione" 'edet      var     pippowa.3
        LabelErrori(4).Text = "S. Acqua" 'eacqua    var     pippowa.4
        LabelErrori(5).Text = "S. Lambda" 'elambda   var     pippowa.5
        LabelErrori(6).Text = "S. Pressione" 'epres     var     pippowa.6
        LabelErrori(7).Text = "Farfalla" 'efarfa    var     pippowa.7
        LabelErrori(8).Text = "S. Fase" 'ecamma    var     pippowb.0
        LabelErrori(9).Text = "Seq. Dati" 'eseqdat   var     pippowb.1
        LabelErrori(10).Text = "Eprom" 'eepr      var     pippowb.2
        LabelErrori(11).Text = "Eeprom" 'eeepr     var     pippowb.3
        LabelErrori(12).Text = " " 'non usato var     pippowb.4
        LabelErrori(13).Text = " " 'non usato var     pippowb.5
        LabelErrori(14).Text = "Ram" 'eram      var     pippowb.6
        LabelErrori(15).Text = "S. Motore" 'esmot     var     pippowb.7

        For i = 0 To 15
            If LabelErrori(i).Text = " " Then
                LabelErrori(i).Enabled = False
            Else
                LabelErrori(i).Enabled = True
            End If
        Next i
    End Sub

    Public Sub Evo()

        Dim i As Byte

        Check(0).Enabled = True 'giri
        ProgressBar(0).Enabled = True
        Label(0).Enabled = True

        Check(1).Enabled = True 'iniezione
        ProgressBar(1).Enabled = True
        Label(1).Enabled = True

        Check(2).Enabled = True 'anticipo accenzione
        ProgressBar(2).Enabled = True
        Label(2).Enabled = True

        Check(3).Enabled = True 'pressione
        ProgressBar(3).Enabled = True
        Label(3).Enabled = True

        Check(4).Enabled = True 'pressione2
        ProgressBar(4).Enabled = True
        Label(4).Enabled = True

        Check(5).Enabled = True 'boost
        ProgressBar(5).Enabled = True
        Label(5).Enabled = True

        Check(6).Enabled = True 'farfalla
        ProgressBar(6).Enabled = True
        Label(6).Enabled = True

        Check(7).Enabled = True 'fase iniezione
        ProgressBar(7).Enabled = True
        Label(7).Enabled = True

        Check(8).Enabled = True 'vae
        ProgressBar(8).Enabled = True
        Label(8).Enabled = True

        Check(9).Enabled = False 'correzione lambda
        ProgressBar(9).Enabled = False
        Label(9).Enabled = False

        Check(10).Enabled = True 'temp aria
        ProgressBar(10).Enabled = True
        Label(10).Enabled = True

        Check(11).Enabled = True 'temp acqua
        ProgressBar(11).Enabled = True
        Label(11).Enabled = True

        Check(12).Enabled = True 'batteria
        ProgressBar(12).Enabled = True
        Label(12).Enabled = True

        Check(13).Enabled = True 'trimmer
        ProgressBar(13).Enabled = True
        Label(13).Enabled = True

        Check(14).Enabled = False 'temp gas
        ProgressBar(14).Enabled = False
        Label(14).Enabled = False

        Check(15).Enabled = True 'errori

        'pippowa   var     pippow.lowbyte
        'pippowb   var     pippow.highbyte
        LabelErrori(0).Text = "S. Fase" 'ecamma    var     pippowa.0
        LabelErrori(1).Text = "Seq. Dati" 'eseqdat   var     pippowa.1
        LabelErrori(2).Text = "S. Aria" 'earia     var     pippowa.2
        LabelErrori(3).Text = "Detonazione" 'edet      var     pippowa.3
        LabelErrori(4).Text = "S. Acqua" 'eacqua    var     pippowa.4
        LabelErrori(5).Text = "S. Motore" 'esmot     var     pippowa.5
        LabelErrori(6).Text = "A.P.S. 1" 'epres1    var     pippowa.6
        LabelErrori(7).Text = "Farfalla" 'efarfa    var     pippowa.7
        LabelErrori(8).Text = "A.P.S. 2" 'epres2    var     pippowb.0
        LabelErrori(9).Text = " " 'non usato var     pippowb.1
        LabelErrori(10).Text = " " 'non usato var     pippowb.2
        LabelErrori(11).Text = " " 'non usato var     pippowb.3
        LabelErrori(12).Text = " " 'non usato var     pippowb.4
        LabelErrori(13).Text = " " 'non usato var     pippowb.5
        LabelErrori(14).Text = " " 'non usato var     pippowb.6
        LabelErrori(15).Text = " " 'non usato var     pippowb.7

        For i = 0 To 15
            If LabelErrori(i).Text = " " Then
                LabelErrori(i).Enabled = False
            Else
                LabelErrori(i).Enabled = True
            End If
        Next i
    End Sub

    Public Sub Evog()

        Dim i As Byte

        Check(0).Enabled = True 'giri
        ProgressBar(0).Enabled = True
        Label(0).Enabled = True

        Check(1).Enabled = True 'iniezione
        ProgressBar(1).Enabled = True
        Label(1).Enabled = True

        Check(2).Enabled = True 'anticipo accenzione
        ProgressBar(2).Enabled = True
        Label(2).Enabled = True

        Check(3).Enabled = True 'pressione
        ProgressBar(3).Enabled = True
        Label(3).Enabled = True

        Check(4).Enabled = True 'pressione2
        ProgressBar(4).Enabled = True
        Label(4).Enabled = True

        Check(5).Enabled = True 'boost
        ProgressBar(5).Enabled = True
        Label(5).Enabled = True

        Check(6).Enabled = True 'farfalla
        ProgressBar(6).Enabled = True
        Label(6).Enabled = True

        Check(7).Enabled = True 'fase iniezione
        ProgressBar(7).Enabled = True
        Label(7).Enabled = True

        Check(8).Enabled = True 'vae
        ProgressBar(8).Enabled = True
        Label(8).Enabled = True

        Check(9).Enabled = False 'correzione lambda
        ProgressBar(9).Enabled = False
        Label(9).Enabled = False

        Check(10).Enabled = True 'temp aria
        ProgressBar(10).Enabled = True
        Label(10).Enabled = True

        Check(11).Enabled = True 'temp acqua
        ProgressBar(11).Enabled = True
        Label(11).Enabled = True

        Check(12).Enabled = True 'batteria
        ProgressBar(12).Enabled = True
        Label(12).Enabled = True

        Check(13).Enabled = True 'trimmer
        ProgressBar(13).Enabled = True
        Label(13).Enabled = True

        Check(14).Enabled = True 'temp gas
        ProgressBar(14).Enabled = True
        Label(14).Enabled = True

        Check(15).Enabled = True 'errori

        'pippowa   var     pippow.lowbyte
        'pippowb   var     pippow.highbyte
        LabelErrori(0).Text = "S. Fase" 'ecamma    var     pippowa.0
        LabelErrori(1).Text = "Seq. Dati" 'eseqdat   var     pippowa.1
        LabelErrori(2).Text = "S. Aria" 'earia     var     pippowa.2
        LabelErrori(3).Text = "Detonazione" 'edet      var     pippowa.3
        LabelErrori(4).Text = "S. Acqua" 'eacqua    var     pippowa.4
        LabelErrori(5).Text = "S. Motore" 'esmot     var     pippowa.5
        LabelErrori(6).Text = "A.P.S. 1" 'epres1    var     pippowa.6
        LabelErrori(7).Text = "Farfalla" 'efarfa    var     pippowa.7
        LabelErrori(8).Text = "A.P.S. 2" 'epres2    var     pippowb.0
        LabelErrori(9).Text = " " 'non usato var     pippowb.1
        LabelErrori(10).Text = " " 'non usato var     pippowb.2
        LabelErrori(11).Text = " " 'non usato var     pippowb.3
        LabelErrori(12).Text = " " 'non usato var     pippowb.4
        LabelErrori(13).Text = " " 'non usato var     pippowb.5
        LabelErrori(14).Text = " " 'non usato var     pippowb.6
        LabelErrori(15).Text = " " 'non usato var     pippowb.7

        For i = 0 To 15
            If LabelErrori(i).Text = " " Then
                LabelErrori(i).Enabled = False
            Else
                LabelErrori(i).Enabled = True
            End If
        Next i
    End Sub

    Public Sub i8v()

        Dim i As Byte

        Check(0).Enabled = True 'giri
        ProgressBar(0).Enabled = True
        Label(0).Enabled = True

        Check(1).Enabled = True 'iniezione
        ProgressBar(1).Enabled = True
        Label(1).Enabled = True

        Check(2).Enabled = True 'anticipo accenzione
        ProgressBar(2).Enabled = True
        Label(2).Enabled = True

        Check(3).Enabled = True 'pressione
        ProgressBar(3).Enabled = True
        Label(3).Enabled = True

        Check(4).Enabled = False 'pressione2
        ProgressBar(4).Enabled = False
        Label(4).Enabled = False

        Check(5).Enabled = False 'boost
        ProgressBar(5).Enabled = False
        Label(5).Enabled = False

        Check(6).Enabled = True 'farfalla
        ProgressBar(6).Enabled = True
        Label(6).Enabled = True

        Check(7).Enabled = True 'fase iniezione
        ProgressBar(7).Enabled = True
        Label(7).Enabled = True

        Check(8).Enabled = True 'vae
        ProgressBar(8).Enabled = True
        Label(8).Enabled = True

        Check(9).Enabled = False 'correzione lambda
        ProgressBar(9).Enabled = False
        Label(9).Enabled = False

        Check(10).Enabled = True 'temp aria
        ProgressBar(10).Enabled = True
        Label(10).Enabled = True

        Check(11).Enabled = True 'temp acqua
        ProgressBar(11).Enabled = True
        Label(11).Enabled = True

        Check(12).Enabled = True 'batteria
        ProgressBar(12).Enabled = True
        Label(12).Enabled = True

        Check(13).Enabled = False 'trimmer
        ProgressBar(13).Enabled = False
        Label(13).Enabled = False

        Check(14).Enabled = False 'temp gas
        ProgressBar(14).Enabled = False
        Label(14).Enabled = False

        Check(15).Enabled = True 'errori

        'pippowa   var     pippow.lowbyte
        'pippowb   var     pippow.highbyte
        LabelErrori(0).Text = "S. Fase" 'ecamma    var     pippowa.0
        LabelErrori(1).Text = "Seq. Dati" 'eseqdat   var     pippowa.1
        LabelErrori(2).Text = "S. Aria" 'earia     var     pippowa.2
        LabelErrori(3).Text = " " 'non usato var     pippowa.3
        LabelErrori(4).Text = "S. Acqua" 'eacqua    var     pippowa.4
        LabelErrori(5).Text = "S. Motore" 'esmot     var     pippowa.5
        LabelErrori(6).Text = "Pressione" 'epres1    var     pippowa.6
        LabelErrori(7).Text = "Farfalla" 'efarfa    var     pippowa.7
        LabelErrori(8).Text = " " 'non usato var     pippowb.0
        LabelErrori(9).Text = " " 'non usato var     pippowb.1
        LabelErrori(10).Text = " " 'non usato var     pippowb.2
        LabelErrori(11).Text = " " 'non usato var     pippowb.3
        LabelErrori(12).Text = " " 'non usato var     pippowb.4
        LabelErrori(13).Text = " " 'non usato var     pippowb.5
        LabelErrori(14).Text = " " 'non usato var     pippowb.6
        LabelErrori(15).Text = " " 'non usato var     pippowb.7

        For i = 0 To 15
            If LabelErrori(i).Text = " " Then
                LabelErrori(i).Enabled = False
            Else
                LabelErrori(i).Enabled = True
            End If
        Next i
    End Sub

    Public Sub i8vg()

        Dim i As Byte

        Check(0).Enabled = True 'giri
        ProgressBar(0).Enabled = True
        Label(0).Enabled = True

        Check(1).Enabled = True 'iniezione
        ProgressBar(1).Enabled = True
        Label(1).Enabled = True

        Check(2).Enabled = True 'anticipo accenzione
        ProgressBar(2).Enabled = True
        Label(2).Enabled = True

        Check(3).Enabled = True 'pressione
        ProgressBar(3).Enabled = True
        Label(3).Enabled = True

        Check(4).Enabled = False 'pressione2
        ProgressBar(4).Enabled = False
        Label(4).Enabled = False

        Check(5).Enabled = False 'boost
        ProgressBar(5).Enabled = False
        Label(5).Enabled = False

        Check(6).Enabled = True 'farfalla
        ProgressBar(6).Enabled = True
        Label(6).Enabled = True

        Check(7).Enabled = True 'fase iniezione
        ProgressBar(7).Enabled = True
        Label(7).Enabled = True

        Check(8).Enabled = True 'vae
        ProgressBar(8).Enabled = True
        Label(8).Enabled = True

        Check(9).Enabled = False 'correzione lambda
        ProgressBar(9).Enabled = False
        Label(9).Enabled = False

        Check(10).Enabled = True 'temp aria
        ProgressBar(10).Enabled = True
        Label(10).Enabled = True

        Check(11).Enabled = True 'temp acqua
        ProgressBar(11).Enabled = True
        Label(11).Enabled = True

        Check(12).Enabled = True 'batteria
        ProgressBar(12).Enabled = True
        Label(12).Enabled = True

        Check(13).Enabled = False 'trimmer
        ProgressBar(13).Enabled = False
        Label(13).Enabled = False

        Check(14).Enabled = True 'temp gas
        ProgressBar(14).Enabled = True
        Label(14).Enabled = True

        Check(15).Enabled = True 'errori

        'pippowa   var     pippow.lowbyte
        'pippowb   var     pippow.highbyte
        LabelErrori(0).Text = "S. Fase" 'ecamma    var     pippowa.0
        LabelErrori(1).Text = "Seq. Dati" 'eseqdat   var     pippowa.1
        LabelErrori(2).Text = "S. Aria" 'earia     var     pippowa.2
        LabelErrori(3).Text = " " 'non usato var     pippowa.3
        LabelErrori(4).Text = "S. Acqua" 'eacqua    var     pippowa.4
        LabelErrori(5).Text = "S. Motore" 'esmot     var     pippowa.5
        LabelErrori(6).Text = "Pressione" 'epres1    var     pippowa.6
        LabelErrori(7).Text = "Farfalla" 'efarfa    var     pippowa.7
        LabelErrori(8).Text = " " 'non usato var     pippowb.0
        LabelErrori(9).Text = " " 'non usato var     pippowb.1
        LabelErrori(10).Text = " " 'non usato var     pippowb.2
        LabelErrori(11).Text = " " 'non usato var     pippowb.3
        LabelErrori(12).Text = " " 'non usato var     pippowb.4
        LabelErrori(13).Text = " " 'non usato var     pippowb.5
        LabelErrori(14).Text = " " 'non usato var     pippowb.6
        LabelErrori(15).Text = " " 'non usato var     pippowb.7

        For i = 0 To 15
            If LabelErrori(i).Text = " " Then
                LabelErrori(i).Enabled = False
            Else
                LabelErrori(i).Enabled = True
            End If
        Next i
    End Sub

    Private Sub FaiRange()
        'giri
        ValMin(0) = 0
        ValMax(0) = 9999

        'iniezione
        ValMin(1) = 0
        ValMax(1) = 262.1

        'anticipo accenzione
        ValMin(2) = 0
        ValMax(2) = 63.8

        'pressione
        ValMin(3) = 0
        ValMax(3) = 2.238

        'pressione2
        ValMin(4) = 0
        ValMax(4) = 2.238

        'boost
        ValMin(5) = 0
        ValMax(5) = 100

        'farfalla
        ValMin(6) = 0
        ValMax(6) = 90.1

        'fase iniezione
        ValMin(7) = 0
        ValMax(7) = 720

        'vae
        ValMin(8) = 0
        ValMax(8) = 100.1

        'correzione lambda
        ValMin(9) = 0
        ValMax(9) = 8.21

        'temp aria
        ValMin(10) = -55
        ValMax(10) = 125.1

        'temp acqua
        ValMin(11) = -55
        ValMax(11) = 125.1

        'batteria
        ValMin(12) = 0
        ValMax(12) = 15.1

        'trimmer
        ValMin(13) = -170
        ValMax(13) = 85

        'temp gas
        ValMin(14) = -20
        ValMax(14) = 1250

    End Sub

    Private Sub Disegna(ByVal inizio As Long)
        Dim X, Y, i As Integer
        Dim OldX(16), OldY(16) As Integer
        Dim max As Single
        Dim bm As New Bitmap(PictureGrafico.Width, PictureGrafico.Height)
        Dim gr As Graphics = Graphics.FromImage(bm)
        Dim colore(16) As System.Drawing.Pen


        colore(0) = Pens.WhiteSmoke
        colore(1) = Pens.Red
        colore(2) = Pens.Orange
        colore(3) = Pens.Yellow
        colore(4) = Pens.Lime
        colore(5) = Pens.Cyan
        colore(6) = Pens.Blue
        colore(7) = Pens.Fuchsia
        colore(8) = Pens.Gray
        colore(9) = Pens.Maroon
        colore(10) = Pens.Goldenrod
        colore(11) = Pens.Olive
        colore(12) = Pens.Green
        colore(13) = Pens.Teal
        colore(14) = Pens.Purple

        gr.Clear(Color.Black)

        For i = 0 To 15
            OldX(i) = 0
            OldY(i) = PictureGrafico.Height + 1
        Next
        max = inizio + PictureGrafico.Width
        If (max > (Lettura.Length - 1)) Then
            max = Lettura.Length - 1
        End If
        For X = inizio To max

            If OldY(Lettura(X).Parametro) > PictureGrafico.Height Then
                OldX(Lettura(X).Parametro) = X - inizio
                OldY(Lettura(X).Parametro) = (PictureGrafico.Height - 1) - ((Lettura(X).Valore - ValMin(Lettura(X).Parametro)) * (PictureGrafico.Height - 1) / (ValMax(Lettura(X).Parametro) - ValMin(Lettura(X).Parametro)))
            Else
                Y = (PictureGrafico.Height - 1) - ((Lettura(X).Valore - ValMin(Lettura(X).Parametro)) * (PictureGrafico.Height - 1) / (ValMax(Lettura(X).Parametro) - ValMin(Lettura(X).Parametro)))

                'fai linea da oldx,oldy a x,y

                gr.DrawLine(colore(Lettura(X).Parametro), OldX(Lettura(X).Parametro), OldY(Lettura(X).Parametro), X - inizio, Y)

                OldX(Lettura(X).Parametro) = X - inizio
                OldY(Lettura(X).Parametro) = Y
            End If

        Next
        If SuGrafico Then gr.DrawLine(Pens.White, Barra, 0, Barra, PictureGrafico.Height)

        PictureGrafico.Image = bm
        PictureGrafico.Refresh()

        gr.Dispose()
    End Sub

    Private Sub HScrollBar_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar.Scroll

        Disegna(HScrollBar.Value)

    End Sub

    Private Sub PictureGrafico_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureGrafico.MouseMove
        Dim Pos As Single
        Pos = HScrollBar.Value + Val(e.X)
        If Pos < (Lettura.Length - 1) Then
            Label(Lettura(Pos).Parametro).Text = CStr(Lettura(Pos).Valore)
            ProgressBar(Lettura(Pos).Parametro).Value = (Lettura(Pos).Valore - ValMin(Lettura(Pos).Parametro)) * (10 ^ ValDec(Lettura(Pos).Parametro))
            LabelTime.Text = Mid(Lettura(Pos).Tempo, 12, 8)
        End If
        SuGrafico = True
        Barra = Val(e.X)
        Disegna(HScrollBar.Value)
    End Sub

    Private Sub MainForm_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        Dim i As Byte

        If SuGrafico Then
            SuGrafico = False
            Disegna(HScrollBar.Value)
            For i = 0 To 14
                Label(i).Text = ""
                ProgressBar(i).Value = 0
            Next
            LabelTime.Text = "00:00:00"
        End If
    End Sub

    Private Sub MainForm_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        PictureGrafico.Width = Me.Width - 423
        PictureGrafico.Height = Me.Height - 113
        HScrollBar.Width = Me.Width - 423
        HScrollBar.Top = Me.Height - 73
        LabelTime.Left = Me.Width - 153
    End Sub

    Private Sub MainForm_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        Disegna(HScrollBar.Value)
    End Sub

    Private Sub ButtonCarica_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCarica.Click
        Dim Nome, Linea As String
        Dim fileReader As System.IO.StreamReader
        Dim stringReader, c As String
        Dim i As Single
        Dim p1, p2 As Long

        OpenFileDialog.ShowDialog()
        Nome = OpenFileDialog.FileName

        fileReader = My.Computer.FileSystem.OpenTextFileReader(Nome)
        stringReader = fileReader.ReadLine()
        i = 1
        While Not (stringReader = "")
            ReDim Preserve Lettura(i)
            Linea = stringReader
            p1 = 1
            c = Mid(Linea, p1, 1)
            While c <> ";"
                p1 = p1 + 1
                c = Mid(Linea, p1, 1)
            End While
            Lettura(i - 1).Tempo = Mid(Linea, 1, p1 - 1)

            p2 = p1 + 1
            c = Mid(Linea, p2, 1)
            While c <> ";"
                p2 = p2 + 1
                c = Mid(Linea, p2, 1)
            End While
            Lettura(i - 1).Parametro = Val(Mid(Linea, p1 + 1, p2 - p1 - 1))

            Lettura(i - 1).Valore = CSng(Mid(Linea, p2 + 1, Len(Linea) - p2))

            'Controllo sulla correttezza dei dati utile per annullare eventuali errori di interpretazione del firmware
            If Lettura(i - 1).Valore > ValMax(Lettura(i - 1).Parametro) Then Lettura(i - 1).Valore = Lettura(i - 1).Valore / 10
            If Lettura(i - 1).Valore < ValMin(Lettura(i - 1).Parametro) Then Lettura(i - 1).Valore = Lettura(i - 1).Valore * 10

            i = i + 1
            stringReader = fileReader.ReadLine()
        End While
        If i > PictureGrafico.Width Then
            HScrollBar.Maximum = i - PictureGrafico.Width
        Else
            HScrollBar.Maximum = 0
        End If
        HScrollBar.Value = 0
        Disegna(0)

    End Sub

    Private Sub ButtonSalva_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSalva.Click
        If ButtonSalva.BackColor = Color.Red Then
            ButtonSalva.BackColor = System.Drawing.ColorTranslator.FromOle(&H8000000F)
            Registra = False
            ButtonCarica.Enabled = True
        Else
            NomeFile = CStr(Now)
            NomeFile = Replace(NomeFile, "/", ".")
            NomeFile = Replace(NomeFile, " ", "_")
            NomeFile = "DCLog_" & NomeFile & ".txt"
            Registra = True
            ButtonSalva.BackColor = Color.Red
            ButtonCarica.Enabled = False
        End If

    End Sub

    Private Sub ButtonAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAbout.Click
        SplashScreen.Show()
        Me.Hide()
    End Sub

End Class