'    Digital-Check Logger
'    --------------------
'    Copyright (C) 2008 Sandro Barsi 
'
'    This program is free software: you can redistribute it and/or modify it 
'    under the terms of the GNU General Public License as published by the Free 
'    Software Foundation version 3 of the License. 
'    This program is distributed in the hope that it will be useful, but WITHOUT 
'    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
'    FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
'    more details. 
'    You should have received a copy of the GNU General Public License along with 
'    this program. If not, see http://www.gnu.org/licenses/. 
'
'    Per contattarmi puoi visitare il sito http://www.lambdatechnology.it    
'    o scrivermi ad uno dei seguenti indirizzi      info@lambdatechnology.it 
'                                                   s.barsi@tin.it
'
'
Public NotInheritable Class SplashScreen

    Private Sub SplashScreen_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If My.Application.Info.Title <> "" Then
            LabelApplication.Text = My.Application.Info.Title
        Else
            'Se manca il titolo dell'applicazione, verr utilizzato il nome dell'applicazione, senza l'estensione
            LabelApplication.Text = System.IO.Path.GetFileNameWithoutExtension(My.Application.Info.AssemblyName)
        End If
        'Formatta le informazioni sulla versione utilizzando come stringa di formattazione il testo impostato nel controllo Version in fase di esecuzione.
        '  Questo consente una localizzazione efficace, se desiderato.
        '  Le informazioni sulla build e la revisione possono essere incluse utilizzando il codice seguente e modificando 
        '  in "Versione {0}.{1:00}.{2}.{3}", o simile, il testo del controllo Version impostato in fase di progettazione.
        '  Per ulteriori informazioni, vedere String.Format() nella Guida.
        '
        '    Version.Text = System.String.Format(Version.Text, My.Application.Info.Version.Major, My.Application.Info.Version.Minor, My.Application.Info.Version.Build, My.Application.Info.Version.Revision)

        ' LabelVersion.Text = System.String.Format(LabelVersion.Text, My.Application.Info.Version.Major, My.Application.Info.Version.Minor)
        LabelVersion.Text = System.String.Format(LabelVersion.Text, My.Application.Info.Version.Major, My.Application.Info.Version.Minor, My.Application.Info.Version.Build, My.Application.Info.Version.Revision)

        'Informazioni sul copyright
        LabelCopyright.Text = My.Application.Info.Copyright
        TextLicEng.Visible = False
        TextLicIta.Visible = False

    End Sub

    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click
        MainForm.Show()
        Me.Hide()
    End Sub

    Private Sub ButtonLicEng_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLicEng.Click
        If TextLicEng.Visible = False Then
            TextLicEng.Visible = True
            TextLicIta.Visible = False
        Else
            TextLicEng.Visible = False
        End If
    End Sub

    Private Sub ButtonLicIta_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLicIta.Click
        If TextLicIta.Visible = False Then
            TextLicIta.Visible = True
            TextLicEng.Visible = False
        Else
            TextLicIta.Visible = False
        End If
    End Sub
End Class